package gq.unurled.raxen.listener.entity;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.entity.EntityNamespacedKey;
import gq.unurled.raxen.components.items.Attributes;
import gq.unurled.raxen.components.player.Skills;
import gq.unurled.raxen.manager.ProfileManager;
import gq.unurled.raxen.utils.Items;
import org.bukkit.attribute.Attribute;
import org.bukkit.entity.Entity;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;

public class DamageEntity implements Listener {
    private Raxen main;
    private ProfileManager profileManager;
    private EntityNamespacedKey entityNamespacedKey;

    public DamageEntity(Raxen main) {
        this.main = main;
        this.profileManager = main.getProfileManager();
        this.entityNamespacedKey = new EntityNamespacedKey(main);
    }

    @EventHandler
    public void entityDamageByEntity(EntityDamageByEntityEvent e) {
        e.setDamage(0);
        Integer damage = 1;
        Integer strength = 0;
        Integer itemDmg = 0;
        Integer defense = 0;
        Integer itemDefense = 0;
        Integer health = 0;
        Integer itemHealth = 0;
        Integer initDamage = 0;
        if (e.getDamager() instanceof Player) {
            Player playerDamager = (Player) e.getDamager();
            Skills skills = profileManager.getPlayerProfile(playerDamager.getUniqueId()).getSkils();
            strength = skills.getStrength();
            itemDmg = skills.getItemDmg();
        } else {
            Entity entityDamager = e.getDamager();
            PersistentDataContainer data = entityDamager.getPersistentDataContainer();
            if (data.has(entityNamespacedKey.strengthKey, PersistentDataType.INTEGER)) {
                strength = data.get(entityNamespacedKey.strengthKey, PersistentDataType.INTEGER);
            }
            Attributes attributes = Items.getNbtFromEntity((LivingEntity) entityDamager);
            itemDmg = attributes.getStrength();
        }
        if (e.getEntity() instanceof Player) {
            Player playerVictim = (Player) e.getEntity();
            Skills skills = profileManager.getPlayerProfile(playerVictim.getUniqueId()).getSkils();
            defense = skills.getDefense();
            health = skills.getHealth();
            itemDefense = skills.getItemDefense();
            itemHealth = skills.getItemHealth();
        } else {
            Entity entityVictim = e.getEntity();
            PersistentDataContainer data = entityVictim.getPersistentDataContainer();
            if (data.has(entityNamespacedKey.defenseKey, PersistentDataType.INTEGER)) {
                defense = data.get(entityNamespacedKey.defenseKey, PersistentDataType.INTEGER);
            }
            if (data.has(entityNamespacedKey.healthKey, PersistentDataType.INTEGER)) {
                health = data.get(entityNamespacedKey.healthKey, PersistentDataType.INTEGER);
            }
            Attributes attributes = Items.getNbtFromEntity((LivingEntity) entityVictim);
            itemDefense = attributes.getDefense();
            itemHealth = attributes.getHealth();
        }
        initDamage = (5+ itemDmg) * (1+ (strength/100));
        damage = initDamage;
        defense = defense + itemDefense;
        defense = defense/(defense+100);
        damage = damage*defense;
        if (damage >= health) {
            e.setDamage(e.getEntity().getType().getDefaultAttributes().getAttribute(Attribute.GENERIC_MAX_HEALTH).getDefaultValue());
        } else {
            health = health - damage;
            if (e.getEntity() instanceof Player) {
                Player playerVictim = (Player) e.getEntity();
                Skills skills = profileManager.getPlayerProfile(playerVictim.getUniqueId()).getSkils();
                skills.setHealth(health);
            } else {
                Entity entityVictim = e.getEntity();
                PersistentDataContainer data = entityVictim.getPersistentDataContainer();
                data.set(entityNamespacedKey.healthKey, PersistentDataType.INTEGER, health);
            }
        }
    }
}
